%Global simulation
load('WSrange_noise_single','state','uRHC','JRHC','X00');
global u01;
Nt=15;
disp(uRHC);
u_vector=[uRHC(1:Nt),uRHC(Nt)];
t_vector=0:Nt;
figure(1) %Figure 11a
stairs(t_vector,u_vector,'r');
title('Range adaptation and Process with perturbation');
xlabel('time [h]');
ylabel('control variable: u ');
text(4.,1.6,'alfa=0.2','FontSize',12);
axis([0,15,0.,2.]);
grid MINOR;


n=9;
%Tglobal=zeros(1,10*Nt);
Tg=zeros(1,(n+1)*Nt);
Xg=zeros((n+1)*Nt:5);
for k=0:Nt-1
    u01=uRHC(k+1);
    T=k:1/n:k+1;
    X0k=state(k+1,:);
    [~,Y] = ode23('PRProdStep',T,X0k); %options);
%     disp(Y);
    Tg(1,k*(n+1)+1:(k+1)*(n+1))=T(1,1:n+1);
    Xg(k*(n+1)+1:(k+1)*(n+1),1:5)=Y(1:(n+1),1:5);
  
end
figure (2); %Fig 11b
plot(Tg,3*Xg(:,1),'r',Tg,3*Xg(:,2),'k',Tg,3*Xg(:,3),'g',Tg,Xg(:,4),'b',Tg,Xg(:,5),'m');
title('Perturbated state evolution');
xlabel('time [h]');
ylabel('state variables');
text(6.,9.,'J_{opt}=34.69','FontSize',12);
%The value is recorded in the file "WSBestEvolution" and 
% dsplayed by line#28
grid MINOR;
legend('3x1','3x2','3x3','x4','x5','Location','NorthWest');