% Draw Figure 7a_b
% Best command profile and the best trajectory
Nt=15;
X00=[0. 0. 1. 5. 1.];
load('WSBestEvolution','BestCMProfile','Trajectory','Jopt');
t_fin=Nt;
%Global simulation
%global u_vector;
%u_vector=[uRHC(1:Nt),uRHC(Nt)];
global t_vector u_vector;
u_vector=[BestCMProfile(1:Nt),BestCMProfile(Nt)];

t_vector=0:1:Nt;
figure(1)
stairs(t_vector,u_vector,'r');
title('Open loop: best control profile');
xlabel('time [h]');
ylabel('control variable: u ');
grid MINOR;
% hold on
% stairs(t_vector,u_vector1,'b');

global command_index; 
command_index=1;
options = odeset('RelTol',1e-1,'MaxStep',0.1);
[T,Y] = ode23('PRProd',[0,t_fin],X00,options);

disp('Jopt=');
disp(Jopt);
% 
figure(2)
plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
title('Open-loop:the best state evolution');
xlabel('time [h]');
ylabel('state variables');
text(6.,9.,'J_{opt}=31.930','FontSize',12);
%The value is recorded in the file "WSBestEvolution" and 
% dsplayed by line#28
grid MINOR;
legend('x1','x2','x3','x4','x5','Location','NorthWest');