% Draw Figure 5
% Best command profile and the best trajectory
% The adapted range of the control output

X00=[0. 0. 1. 5. 1.];
load('WSBestEvolution','BestCMProfile','Trajectory','Jopt');
load('WSPuRHC','uRHC','Nt','X00');
xmin0=0.;
xmax0=2.0;
alfa=0.2;
str=sprintf(' ALFA=%4.2f\n', alfa);
disp(str);
du=alfa*(xmax0-xmin0);
duvect=du+zeros(1,Nt+1);

u_vector1=[BestCMProfile(1:Nt),BestCMProfile(Nt)];
maxbound=u_vector1+duvect;

minbound=u_vector1-duvect;
for i=1:Nt+1
    if (maxbound(i)>xmax0)
        maxbound(i)=xmax0;
    end
    if (minbound(i)<xmin0)
        minbound(i)=xmin0;
    end
end
RHCcmd=[uRHC(1:Nt),uRHC(Nt)];
%global t_vector;
t_vector=0:1:Nt;
figure(1);

stairs(t_vector,maxbound,'k');
hold on;
stairs(t_vector,minbound,'g','LineWidth',1);
title('Control variable''s range');
hold on;
stairs(t_vector,u_vector1,'b');
hold on;
stairs(t_vector,RHCcmd,'r');


axis([0, 15,-0.1,2.1]);

legend('max bound','min bound','u-reference','u-Controller','Location','NorthWest');
%legend BOXOFF;
hold on
plot([0,Nt],[0,0],'-.g', [0,Nt],[2,2],'-.k');

hold off;