% Aloritm evolutiv pentru rezolvarea problemelor de control optimal
% Rezolvarea Problema PARK-RAMIREZ
% cu zgomot pe stare
L=0.1;
%lim=0.005;
str=sprintf('Executie cu EA_PP_RHC.m');disp(str);
str=sprintf('Selectie cu Stochastic Universal Sampling');disp(str);
str=sprintf('Utilizare Rank si Scalare Rank');disp(str);
str=sprintf('Replacement: in ultimele lambda pozitii');disp(str);
str=sprintf('             din cele N ale populatiei');disp(str);
str=sprintf('Incrucisare: Intr-un singur punct');disp(str);
str=sprintf('             -produce unui singur urmas');disp(str);
str=sprintf('Mutatie: gaussiana adaptiva');disp(str);
str=sprintf('STARE CITITA CU ZGOMOT UNIFORM');disp(str);
global t_vector;
global h Nt N s;
global pop;
global CHILD;
global ngene NGen;
global pop_zero;
global xmin xmax;
global dTdtmax;
global fc fcCHILD;

global amic mc msc;
global k;
global nr_fii;
global sigma;
global X00;
N=50;              % N=nr de cromozomi din populatie
nr_fii=20;
NGen=60;     % NGen=nr de generatii
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);
dTdtmax=0.1;
xmin=0.;
xmax=2.;
Nt=15;
stare=zeros(16,5);
XFZ=zeros(1,5);
parinti=zeros(nr_fii,1);


s=1.8; %presiune de selectie
str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g L=%g dTdtmax=%g',...
    N, nr_fii,NGen,s,L,dTdtmax);disp(str);
global u1RH;
u1RH=zeros(1,Nt);
pop_zero=zeros(1,Nt);
amic=0.85;
k=0;
X00=[0. 0. 1. 5. 1.];
X0=X00;
%Xk este starea initiala pe orizontul de predictie [k,Nt]
stare(1,:)=X0; %memorare stare initiala
t_vector=0:1:Nt; %are Nt+1 elemente
R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;


while k<=(Nt-1) 
  
  str=sprintf('\n#####  k=%d\n',k);disp(str);
  %k este capatul din stanga al orizontului
  disp('#####  starea curenta=');
  disp(X0);
  h=Nt-k; 
  ngene=h;
sigma=0.2;
mc=0;
msc=0;  
  
%****************************
%****************************
%****************************
%AHR            INCEPUT

pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);

%Generare populatie initiala
 for i=1:N
    for j=1:ngene     
          pop(i,j)=random('unif',xmin,xmax);
    end 
    pop(i,:)=StepCtrl(pop(i,:));
 end
 
%Evaluare initiala
for i=1:N
	fc(i)=eval_PP_RH_g(pop(i,:),k);
end
[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);


g=1;


%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(g<=NGen)         %&&(gasit==0)

% SELECTIE PARINTI
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

%INCRUCISARE - atentie aici se construiesc (apar) fii
for ii=1:lambda
    if h>1           %pt h>1  fac incrucisare si generez CHILD(ii) (vezi mai jos)
 
      jj=1;%randi(lambda);
      incrucisare2RH(parinti(ii),jj,ii); %un singur copil
      %se incruciseaza pop(parinti(ii),:) cu alt cromozom din lista    
    
    else  %sunt la h=1
        CHILD(ii)=pop(parinti(ii)); % Il initializez dar nu mai incrucisez
    end    
end
%------------------------------
 %MUTATIE (mutatieGaussRH contine si evaluarea)
 for iii=1:lambda
      fcCHILD(iii)=eval_PP_RH_g(CHILD(iii,:),k);
      %Evalure inainte de mutatie pt toti fii (valabila si daca nu voi face mutatie)
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGaussRH_g(iii); %Fac mutatie pe CHILD(iii)
        %In interior se face si StepCtrl si actualizare fcCHILD(iii)
      else
        CHILD(iii,:)=StepCtrl(CHILD(iii,:));
        fcCHILD(iii)=eval_PP_RH_g(CHILD(iii,:),k); %Pt ca modific prin step control
      end
 end

 % Copiere fii pe ultimele lambda POZITII din cele N
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 % Reordonare pop dupa fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
 if (mod(g,10)==0)
    str=sprintf('#####   nr. gen=%g sigma=%g Jmax=%g',g,sigma, fc(1));
    disp(str);
 end
 %------------------------------------
 
 g=g+1;

end     %while

%AHR            END  
%****************************
%****************************
%****************************
 %test; 
      % TRIMITERE (SALVARE) COMANDA U(k)
       u1RH(k+1)=pop(1,1); %k incepe de la zero si prima salvare se face la 1
      
  % CITIRE STARE CURENTA pt iteratia urmatoare
  % De fapt AICI SIMULEZ STAREA CURENTA
  XFZ=step_PP_RH(u1RH(k+1),k,X0);
  for ns=1:5
    lim=XFZ(ns)*L;  %L este limita superioara
    zg=random('unif',-lim,lim);
    X0(ns)=XFZ(ns)+zg;
  end
  %X0 devine noua stare initiala

  k=k+1;  %k pt iteratia urmatoare
  %memorare stare initiala
  if (k==(Nt-1))
      stare(k+1,:)=XFZ;
  else
      stare(k+1,:)=X0;
  end
  
end


%sim_PP_RH_RPM5;


