% New article mdpi-Electronics
% Special Issue: Predictive and Learning Control in Engineering Applications
% RHC using Evolutionary Algorithm for solving an Optimal Control Problem
% (PARK-RAMIREZ problem)

xmin0=0.;
xmax0=2.0;
alfa=0.2;
str=sprintf(' ALFA=%4.2f\n', alfa);
disp(str);
du=alfa*(xmax0-xmin0);

global Nt;
Nt=15;

global xmin xmax;% xmin, xmax are the bounds of the control outputs


uRHC=zeros(1,Nt);
state=zeros(Nt+1,5);
%Compute control outputs range
load('WSBestEvolution','BestCMProfile','Trajectory','Jopt');

WithRangeCTRL=1;

% Set the bounds of the control outputs

if (WithRangeCTRL==1)
    xmin=BestCMProfile-du;
    xmax=BestCMProfile+du;
    for i=1:Nt
      if (xmin(i)<xmin0)
         xmin(i)=xmin0;
     end
     if (xmax(i)>xmax0)
         xmax(i)=xmax0;
     end
     disp([xmin(i) xmax(i)]);
    end
     
 else             %WithRangeCTRL==0
    xmin=zeros(1,Nt);
    xmax=2.+zeros(1,Nt);
    disp(xmin);
    disp(xmax);
 end


k=0;

xk=Trajectory(k+1,:);  %xk is the current state (at step k)
global Ncalls Ncalls_C;
Ncalls_C=0;
state(1,:)=xk;




%***************************************************
%***************************************************
%         CLOSED-LOOP control structure
%***************************************************
%***************************************************
while k<=(Nt-1) 
    
   
  str=sprintf('#####                            k=%d', k);
  disp(str);
 % k este capatul din stanga al orizontului de predictie
  %str=sprintf('#####  starea curenta=%7.3f',x0);disp(str);
  
 
 [PredictedSeq,J]=RHC_Predictor_EA2(k,xk);
  Ncalls_C=Ncalls_C+Ncalls; 
 
 %disp(PredictedSeq);
 %disp('length=');
 %disp(length(PredictedSeq));
 %[~, J]=eval_PR_step(PredictedSeq,x0);
str=sprintf('k=%2d  J=%7.4f  Ncalls=%6d  Ncalls_C= %6d', ...
    k, J,Ncalls,Ncalls_C);
disp(str);
disp('****************************************')
%pause;

% TRIMITERE (sau SALVARE) COMANDA U(k)
 uk=PredictedSeq(1);
 uRHC(k+1)=uk;       %store the current control output
str=sprintf('&&&  control output=%7.4f ',uk);
disp(str);
if(uk<xmin(k+1))
  str=sprintf('EROARE  k=%2d  xmin=%7.4f   xmax=%7.4f', ...
    k, xmin(k+1),xmax(k+1));
disp(str); 
end
if(uk>xmax(k+1))
  str=sprintf('EROARE  k=%2d  xmin=%7.4f   xmax=%7.4f', ...
    k, xmin(k+1),xmax(k+1));
disp(str);
end
  % CITIRE STARE CURENTA pt iteratia urmatoare
  % De fapt AICI SIMULEZ STAREA CURENTA
  xnext=RHC_RealProcessStep(uk,xk,k);
  
  %RPM = PM deci nu adaug nimic acum
  
  k=k+1;  %k for the next step
  %memorare stare initiala pt pasul urmator
  state(k+1,:)=xnext; %store the new state
  xk=xnext;
  disp('*********************************////////////');
end
global X00;
X00=[0. 0. 1. 5. 1.];
save('WSPuRHC3','uRHC','Nt','X00');


[staref, JRHC]=Jfinal(uRHC);
disp(staref);
str=sprintf('&&&&    JRHC=%7.4f ',JRHC);
disp(str);




