% PRP-5 states
% RHC without range adaptation 
% Electronics- typical run and drawing

global Nt;
global X00;
t_fin=15;
Nt=15;
global u_vector % vector global cu eval_fi 
global t_vector % vector global cu prog principal
global command_index;
load('WSrange_all_0','UstarRHC','X15','JMAT','NcallsC');
str=sprintf('Avarage performance index is: %7.3f \n',mean(JMAT));
disp(str);
DJ=JMAT-mean(JMAT);
i0=1;
for i=2:40
    if(abs(DJ(i))<abs(DJ(i0)))
        i0=i;
    end
end

X00=[0. 0. 1. 5. 1.];
ustar=UstarRHC(i0,:);

%Afisare evolutie sistem in executie tipica
t=0:1:Nt; %are Nt+1 elemente

str=sprintf('Typical execution:\n\n');disp(str);
disp('i0=');disp(i0);

str=sprintf('Jtypical = %6.4f\n',JMAT(i0));disp(str);
str=sprintf('Xf1=%6.4f Xf5=%6.4f\n',X15(i0,1),X15(i0,2));disp(str);

Minim=min(JMAT);
[Maxim,imax]=max(JMAT);
Var=var(JMAT);
StdJMAT=std(JMAT);
str=sprintf('Minim=%7.4f \nMaxim=%7.4f,\nStd=%6.4f\n',...
    Minim,Maxim,StdJMAT);disp(str);

%**************************************************************
%Global simulation
u_vector=[ustar(1:Nt),ustar(Nt)];
t_vector=0:t_fin;
figure(4) %Figure 9a
stairs(t_vector,u_vector,'r');
title('RHC-loop: Typical  control profile');
xlabel('time [h]');
ylabel('control variable: u ');
axis([0,15,0.,2.]);
grid MINOR;


command_index=1;
options = odeset('RelTol',1e-5,'MaxStep',0.1);
[T,Y] = ode23('PRProd',[0 t_fin],X00,options);
J1=Y(end,1)*Y(end,5); 
disp(J1);

figure(5) %Figure 9b
plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
title('RHC-loop: State evolution ');
axis([0,15,0.,14.]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{3x}_{1}','\it{3x}_{2}','\it{3x}_{3}','\it{x}_{4}','\it{x}_{5}','Location','NorthWest');

text(6.,9.,'J_{typical}=31.9','FontSize',12);
grid MINOR;
%**********************

%Data for Table 1 and 2
for i=1:40
    str=sprintf('%7d',NcallsC(i));disp(str);
end

for i=1:40
    str=sprintf('%6.3f',JMAT(i));disp(str)
end
for i=1:40
 str=sprintf('%2d',i);disp(str);
end
% for i=1:30
%     str=sprintf('%4.2f',X15(i,2));disp(str);
% end
