load('WSPuRHC','uRHC','Nt','X00');
load('WSBestEvolution','BestCMProfile','Trajectory','Jopt');
t_fin=Nt;
%Global simulation
global u_vector;
u_vector=[uRHC(1:Nt),uRHC(Nt)];
u_vector1=[BestCMProfile(1:Nt),BestCMProfile(Nt)];
global t_vector;
t_vector=0:1:Nt;
figure(1)
title('Optimal control - RHC-loop');
stairs(t_vector,u_vector,'r');
hold on
stairs(t_vector,u_vector1,'b');
global command_index; 
command_index=1;
options = odeset('RelTol',1e-5,'MaxStep',0.1);
[T,Y] = ode23('PRProd',[0,t_fin],X00,options);
J1=Y(end,1)*Y(end,5);
disp('J1=');
disp(J1);
% 
figure(2)
plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
title('State evolution for the RHC-loop');
legend('x1','x2','x3','x4','x5','Location','NorthWest');
