
global Nt;

global t_vector u_vector;
global command_index;

load('WSP7range','U1RH','U2RH','X14','JMAT','Ncalls_C'); 
% NcallsC's analysis
AvgNC=mean(Ncalls_C);
MinNC=min(Ncalls_C);
[MaxNC,~]=max(Ncalls_C);
StdNC=std(Ncalls_C);
str=sprintf('MinNC=%6d     AvgNC=%6d     MaxNC=%6d    StdNC=%6.1f\n',...
     MinNC, AvgNC, MaxNC, StdNC);
disp(str);
% J's analysis
AvgJ=mean(JMAT);
MinJ=min(JMAT);
[MaxJ,~]=max(JMAT);
StdJ=std(JMAT);
str=sprintf('MinJ=%5.3f   AvgJ=%5.3f    MaxJ=%5.3f  StdJ=%5.2f\n',...
     MinJ, AvgJ,MaxJ, StdJ);
disp(str);
% Find typical execution i0
DJ=JMAT-AvgJ;
i0=1;
for i=2:30
    if(abs(DJ(i))<abs(DJ(i0)))
        i0=i;
    end
end
str=sprintf('Typical execution=%2d  J(i0)=%5.3f Ncalls(i0)=%6d',...
    i0,JMAT(i0),Ncalls_C(i0));
disp(str);


Q=1.5;
Nt=10;
X00=[1. 0.1 40. 0. 0. 1. 0.];

u1RH=U1RH(i0,:);
u2RH=U2RH(i0,:);

t_vector=0:1:Nt; %are Nt+1 elemente
u_vector(1:Nt)=u1RH;
u_vector(Nt+1:2*Nt)=u2RH;

figure(1) %Figure 12 (a)
stairs(t_vector,[u_vector(1:Nt),u_vector(Nt)],'r','LineWidth',1);
hold on;
stairs(t_vector,[u_vector((Nt+1):2*Nt),u_vector(2*Nt)],'b','LineWidth',1);
title('Control variables with range adaptation');
xlabel('time [h]');
ylabel('control variables: u1, u2 ');
%text(4.,1.6,'alfa=0.2','FontSize',12);
axis([0,10,0.,0.35]);
grid MINOR;
legend('u1','u2','Location','NorthWest');
hold off;
%**************************************************************

str=sprintf('Tf1=%g Tf4=%g\n',X14(i0,1),X14(i0,2));disp(str);

%**************************************************************
figure(2) %Figure 12 (b)
command_index=1;
options = odeset('RelTol',1e-4,'MaxStep',0.1);
[T,Y] = ode45('ProteinProdRH_g',[0 Nt],X00,options);

plot(T,Y(:,1),'r',T,Y(:,2)/3,'--b',T,Y(:,3)/10,'g',T,Y(:,4),'k',...
    T,Y(:,5)*10,'m',T,Y(:,6),'-.b',T,Y(:,7)*10,'c','LineWidth',1);
title('State evolution with range adaptation');
xlabel('time [h]');
ylabel('state variables');
text(1.,5.5,'J_{opt}=5.761','FontSize',12);
axis([0,10,0.,6.5]);
grid MINOR;
legend('x1','x2/3','x3/10','x4','x5*10','x6','x7*10','Location','NorthWest');


IF=length(T); %IF este indicile final
J2=Y(IF,1)*Y(IF,4);
str=sprintf('\n\nX1f=%g X4f=%g\n',Y(IF,1),Y(IF,4));
disp(str);
%*****************************************************************

J1=0; %Calcul integrala din u2 pe t_vector, prin met dreptunghiurior
for n=1:Nt
    J1=J1+u2RH(n);
end

J1=Q*J1;
J=J2-J1;
str=sprintf('J2=%g J1=%g    J=%6.3f',J2,J1,J);
disp(str);


