% New article mdpi-Electronics
% Special Issue: Predictive and Learning Control in Engineering Applications
% RHC using Evolutionary Algorithm for solving an Optimal Control Problem
% Protein Production Problem: nonlinear with 7 state variables
% The objective function has integral component
% There are two control variables
str=sprintf('RHC_EA_PPP_ControlRange.m');
disp(str);
global t_vector;
global h Nt N s;
global pop;
global CHILD;
global ngene NGen;
global pop_zero;
global xmin xmax;
global dTdtmax;
global fc fcCHILD;
global Q;
global amic;
global k;
global nr_fii;
global sigma;
global X00;
global Ncalls;
N=60;              % N=nr de cromozomi din populatie
nr_fii=30;
NGen=60;     % NGen=nr de generatii
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);
dTdtmax=0.1;

Nt=10;
state=zeros(11,7);
XFZ=zeros(1,7);
parinti=zeros(nr_fii,1);
Q=1.5;

s=1.8; %presiune de selectie
str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g Q=%g dTdtmax=%g',...
    N, nr_fii,NGen,s,Q,dTdtmax);disp(str);

global u1RH;
global u2RH;
u1RH=zeros(1,Nt);
u2RH=zeros(1,Nt);
pop_zero=zeros(1,2*Nt);
amic=0.85;
xmin0=0.;
xmax0=1.0;
alfa=0.2;
str=sprintf(' ALFA=%4.2f\n', alfa);
disp(str);
du=alfa*(xmax0-xmin0);
   load('WSBestEvolution','BestCMProfile','Trajectory','Jopt');
% Set the bounds of the control outputs
    xmin=BestCMProfile-du; %xmin is vector 2 x 10
    xmax=BestCMProfile+du; %xmax is vector 2 x 10
    for i=1:Nt
      if (xmin(1,i)<xmin0)
         xmin(1,i)=xmin0;
      end
      if (xmin(2,i)<xmin0)
         xmin(2,i)=xmin0;
      end
      if (xmax(1,i)>xmax0)
         xmax(1,i)=xmax0;
      end
      if (xmax(2,i)>xmax0)
         xmax(2,i)=xmax0;
      end
     disp([xmin(1,i) xmax(1,i) xmin(2,i) xmax(2,i)]);
    end
% ngene=nr. gene maxim dintr-un cromozom- am 2 intrari de 10
NcallsC=0;
k=0;
X00=[1. 0.1 40. 0. 0. 1. 0.];
X0=X00;
%Xk este starea initiala pe orizontul de predictie [k,Nt]
state(1,:)=X0; %memorare stare initiala
t_vector=0:1:Nt; %are Nt+1 elemente
R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;

while k<=(Nt-1) 
  str=sprintf('\n#####  k=%d\n',k);disp(str);
  %k este capatul din stanga al orizontului
  disp('#####  current state=');
  disp(X0);
 Ncalls=0;
  h=Nt-k; 
  ngene=2*h; %It is variable
 
%****************************
%****************************
%****************************
%AHR            INCEPUT

pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);

%INITIAL POPULATION Generation
 for i=1:N
    for j=1:h     
          pop(i,j)=random('unif',xmin(1,j+k),xmax(1,j+k));
    end
    for j=h+1:ngene     
          pop(i,j)=random('unif',xmin(2,j+k-h),xmax(2,j+k-h));
    end
    pop(i,:)=StepCtrl(pop(i,:));   
 end
 
%Initial Evaluation
for i=1:N
	fc(i)=eval_PP_RH_g(pop(i,:),k);
end
[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);
sigma=0.15;
g=1;
found=0;
%                                      BIG LOOP
% BEGIN
while(g<=NGen) &&(found==0)   

% PARENTS SELECTION
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

% CROSSOVER 
for ii=1:lambda
    if h>1           %pt h>1  fac crossover si generez CHILD(ii) (vezi mai jos)
 
      jj=randi(lambda);
      crossover2RH(parinti(ii),parinti(jj),ii); %un singur copil
      %se incruciseaza pop(parinti(ii),:) cu alt cromozom din lista    
    
    else  %sunt la h=1
        CHILD(ii)=pop(parinti(ii)); % Il initializez dar nu mai incrucisez
    end    
end
%------------------------------
 % Mutation  (GaussRH)
 for iii=1:lambda
      fcCHILD(iii)=eval_PP_RH_g(CHILD(iii,:),k);
      %Evalure inainte de mutatie pt toti fii (valabila si daca nu voi face mutatie)
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGaussRH_g(iii); %Fac mutatie pe CHILD(iii)
        %In interior se face si StepCtrl si actualizare fcCHILD(iii)
      else
        CHILD(iii,:)=StepCtrl(CHILD(iii,:));
        fcCHILD(iii)=eval_PP_RH_g(CHILD(iii,:),k); %Pt ca modific prin step control
      end
 end

 % Copy offspring into the last lambda positions
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 %  Sort again pop according fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
 if (mod(g,10)==0)
    str=sprintf('#####   nr. gen=%2d Jmax=%g ',g, fc(1));
    disp(str);
 end
 if(fc(1)>=5.65)
     found=1;
 end
 %------------------------------------
 
 g=g+1;

end     %while

%AHR            END  
%****************************
%****************************
%****************************
str=sprintf('*****   k=%2d  nr. gen=%2d Jmax=%g  Ncalls=%8d',...
    k, g,fc(1),Ncalls);
disp(str);
      % TRIMITERE (SALVARE) COMANDA U(k)
       u1RH(k+1)=pop(1,1); %k incepe de la zero si prima salvare se face la 1
       u2RH(k+1)=pop(1,h+1);
str=sprintf('*****   u1=%5.3f   u2=%5.3f ',u1RH(k+1),u2RH(k+1));
disp(str);
  % CITIRE STARE CURENTA pt iteratia urmatoare
  % De fapt AICI SIMULEZ STAREA CURENTA
  X0=step_PP_RH(u1RH(k+1),u2RH(k+1),k,X0);
  %X0 devine noua stare initiala
  k=k+1;  %k pt iteratia urmatoare
  %memorare stare initiala
  state(k+1,:)=X0;
  NcallsC=NcallsC+Ncalls;
end
sim_PP_RH;


