%script
% SAVE the results in "RESULTS.txt"
global u_vector;
global command_index;
global Nt;
global Q;
global X00;

u_vector(1:Nt)=u1RH;
u_vector(Nt+1:2*Nt)=u2RH;
FW1 = fopen('RESULTS.txt','w');
str=sprintf('System RHC:\n');
fprintf(FW1,str);disp(str);

for i=1:Nt
    str=sprintf('u1(%d)=%6.4f \n',i, u1RH(i)); % disp(str);
    fprintf(FW1,str);
end

for i=1:Nt
    str=sprintf('u2(%d)=%6.4f \n',i, u2RH(i));%disp(str);
    fprintf(FW1,str);
end

command_index=1;
options = odeset('RelTol',1e-4,'MaxStep',0.1);
[T,Y] = ode23('ProteinProdRH_g',[0 Nt],X00,options);


IF=length(T); 
J2=Y(IF,1)*Y(IF,4);
fprintf(FW1,'\n\nX1f=%g X4f=%g J*=%g\n',Y(IF,1),Y(IF,4));
%*****************************************************************

J1=0; %Compute integral term
for n=1:Nt
    J1=J1+u2RH(n);
end
J1=Q*J1;
JRHC=J2-J1;
str=sprintf('              JRHC=%g   NcallsC=%8d',JRHC,NcallsC);
disp(str);
fprintf(FW1,str);
disp('&&&&&&&&&&&&&');
